
      subroutine Update_Chem (tdt,chem_cycle, londeg, latdeg, kel, 
     &const, humidity, emiss, mcor, qjimp, qkimp, moistq, cmf, press3c,
     &grid_height, ispb, mass, dms_oh, dms_no3, so2_oh, so2_h2o2, so2_o3, 
     &so2_hete,clwc2,ran_cloud,ncol,lchnk) 
      
      use h_imp_dims, only: i1_gl, i2_gl,ju1_gl,j2_gl, ilo,ihi,julo,jhi,
     &k1,k2,i1,i2, ju1,j2,num_emiss, emiss_timpyr,num_qjs,num_qks,
     &num_species
      
      use h_imp_phys_constants
      
      use h_imp_control, only: imgas_num,initrogen_num,ioxygen_num 
      
 !----     
      use cam_history,     only: outfld
 !----   
   
      implicit none
      
      

!     ---------
!     input argument
!     -------------
      real*8  :: chem_cycle ! number of time steps to cycle chemistry calls on, it appears imp_control.h
      real*8  :: tdt ! number of time steps to cycle chemistry calls on, it appears imp_control.h  
      

!     ----------------------
!     Argument to be passed to  Update_Sulfchem
!     ----------------------
 
      real*8,  save :: chemintv = -1.0d0
      real*8  :: londeg  (ju1_gl:j2_gl)                 !passed to Do_Sulf_Solver directly
      real*8  :: latdeg  (ju1_gl:j2_gl)                !passed to Do_Sulf_Solver directly
      real*8  :: kel     (ilo:ihi, julo:jhi, k1:k2)    !used to cal RH, also passed to Do_Sulf_Solver directly
      real*8  :: const   (i1:i2, ju1:j2, k1:k2, num_species) ! changed unit from kg/kg to #/cm3 for gas, pass to solver, change unit back to kg/kg
      real*8  :: humidity(i1:i2, ju1:j2, k1:k2)        !used to cal RH, also passed
      real*8  :: emiss   (i1:i2, ju1:j2, k1:k2, num_emiss)!used to cal sulf_emiss, fSO2,nSO2,nDMS,
      real*8  :: mcor    (i1:i2, ju1:j2)                 ! used to cal sulf_emiss, not passed
      real*8  :: qjimp   (i1:i2, ju1:j2, k1:k2, num_qjs) ! num_qjs=NUM_J=1 (setkin_par.h) it is not input argument but ouput. In chem_update.F/Update_Sulfchem/Do_sulf_init,  qjh2o2_2d2x5_R8.nc is read into  qjh2o2_2d, late in sulfchem_solver.F, it is interpolated and  set qjimp 
      real*8  :: qkimp   (i1:i2, ju1:j2, k1:k2, num_qks) ! num_qks=NUM_K=8 (setkin_par.h), ouput
      real*8  :: moistq  (i1:i2, ju1:j2, k1:k2)          !! NOT used even in original case
      real*8  :: cmf    (i1:i2,  ju1:j2, k1:k2)         !! cmf is used to calculate cumulus cloud fraction, not used anymore
      real*8  :: press3c (ilo:ihi, julo:jhi, k1:k2)      !used for RH, also passed.
      real*8  :: grid_height(i1:i2, ju1:j2, k1:k2)       !used to cal sulf_emiss, not passed.
      integer :: ispb    (i1:i2, ju1:j2, k1:k2)       !the flag for boundary layer: 1, yes; 0: no 
      real*8  :: mass    (i1:i2, ju1:j2, k1:k2)          !passed to Do_Sulf_Solver directly
      real*8  :: dms_oh  (i1:i2, ju1:j2, k1:k2)
      real*8  :: dms_no3 (i1:i2, ju1:j2, k1:k2)
      real*8  :: so2_oh  (i1:i2, ju1:j2, k1:k2)
      real*8  :: so2_h2o2(i1:i2, ju1:j2, k1:k2)
      real*8  :: so2_o3  (i1:i2, ju1:j2, k1:k2)
      real*8  :: so2_hete(i1:i2, ju1:j2, k1:k2)
      real*8  :: clwc2   (i1:i2, ju1:j2, k1:k2) !added by Cheng Zhou
      real*8  :: ran_cloud  (i1:i2, ju1:j2, k1:k2) ! added by Cheng Zhou
      
      integer :: ncol,lchnk    
!     ----------------------
!     local Variable declarations.
!     ----------------------
      logical, save :: first = .true.
      integer :: ix

c!     ----------------
c!     Begin execution.
c!     ----------------

 
c      tdt = 3600.0d0
     
c!     ==========
      if (first) then
c!     ==========
 
        first = .false.
        
        chem_cycle  = 1.0d0
        
        chemintv = tdt * chem_cycle
        
 
      end if
 
c         --------------------------------------------------------
c         Calculate the air density at the center of each grid box
c         (molecules/cm^3).
c         --------------------------------------------------------

c          const(:,:,:,imgas_num) =
c     &      press3c(i1:i2,ju1:j2,:) * MB2CGS /
c     &      (kel (i1:i2,ju1:j2,:) * BOLTZMN_E)


          if (ioxygen_num /= 0) then
            const(:,:,:,ioxygen_num) =
     &        const(:,:,:,imgas_num) * MXRO2
          end if

          if (initrogen_num /= 0) then
            const(:,:,:,initrogen_num) =
     &        const(:,:,:,imgas_num) * MXRN2
          end if
          
 
c !!!!!!!!!!!!!!!!! added by Cheng to output all argument before call the sulfate module
c        print*," londeg    ", londeg   ( :  )
c        print*," latdeg    ", latdeg   ( :  )
c        print*," kel   ", kel  ( :,:,:  )
c        print*," const   ", const  ( :,:,:,:  )
c        print*," humidity    ", humidity   ( :,:,:  )
c        print*," emiss   ", emiss  ( :,:,:,:,1)
c        print*," mcor    ", mcor   ( :,: )
c        print*," qjimp   ", qjimp  ( :,:,:,:  )
c        print*," qkimp   ", qkimp  ( :,:,:,:  )
c        print*," moistq    ", moistq   ( :,:,:  )
c        print*," cmf   ", cmf  ( :,:,:  )
c        print*," press3c   ", press3c  ( :,:,:  )
c        print*," grid_height   ", grid_height  ( :,:,:  )
c        print*," mass    ", mass   ( :,:,:  )
c        print*," dms_oh    ", dms_oh   ( :,:,:  )
c        print*," dms_no3   ", dms_no3  ( :,:,:  )
c        print*," so2_oh    ", so2_oh   ( :,:,:  )
c        print*," so2_h2o2    ", so2_h2o2   ( :,:,:  )
c        print*," so2_o3  ", so2_o3 ( :,:,:  )
c        print*," so2_hete  ", so2_hete ( :,:,:  )
c        print*," clwc2   ", clwc2  ( :,:,:  )
c        print*," ran_cloud   ", ran_cloud  ( :,:,:  )

c!!!!!!!!!!!!!!!! added by Cheng to output all argument before call the sulfate module, end here   
        
!        call outfld("um_VAR3D_02",const(:,:ncol,k2:k1:-1,1),ncol,lchnk)
!        call outfld("um_VAR2D_01",londeg(:ncol),ncol,lchnk)
!        call outfld("um_VAR2D_02",latdeg(:ncol),ncol,lchnk)
        
        Call Update_Sulfchem
     &  (chemintv, londeg, latdeg, kel, const, humidity, emiss, mcor,
     & qjimp, qkimp, moistq, cmf, press3c, grid_height,ispb, mass,
     & dms_oh, dms_no3, so2_oh, so2_h2o2, so2_o3, so2_hete,
     & clwc2,ran_cloud,ncol,lchnk)
     
     
     
c !!!!!!!!!!!!!!!!! added by Cheng to output all argument before call the sulfate module
c        print*,"-----------------------------------------------"
c        print*," londeg    ", londeg   ( :  )
c        print*," latdeg    ", latdeg   ( :  )
c        print*," kel   ", kel  ( :,:,:  )
c        print*," const   ", const  ( :,:,:,:  )
c        print*," humidity    ", humidity   ( :,:,:  )
c        print*," emiss   ", emiss  ( :,:,:,:,1)
c        print*," mcor    ", mcor   ( :,: )
c        print*," qjimp   ", qjimp  ( :,:,:,:  )
c        print*," qkimp   ", qkimp  ( :,:,:,:  )
c        print*," moistq    ", moistq   ( :,:,:  )
c        print*," cmf   ", cmf  ( :,:,:  )
c        print*," press3c   ", press3c  ( :,:,:  )
c        print*," grid_height   ", grid_height  ( :,:,:  )
c        print*," mass    ", mass   ( :,:,:  )
c        print*," dms_oh    ", dms_oh   ( :,:,:  )
c        print*," dms_no3   ", dms_no3  ( :,:,:  )
c        print*," so2_oh    ", so2_oh   ( :,:,:  )
c        print*," so2_h2o2    ", so2_h2o2   ( :,:,:  )
c        print*," so2_o3  ", so2_o3 ( :,:,:  )
c        print*," so2_hete  ", so2_hete ( :,:,:  )
c        print*," clwc2   ", clwc2  ( :,:,:  )
c        print*," ran_cloud   ", ran_cloud  ( :,:,:  )

c!!!!!!!!!!!!!!!! added by Cheng to output all argument before call the sulfate module, end here      
      end
 
 
 
c-----------------------------------------------------------------------------
c
c ROUTINE
c   Update_Sulfchem
c
c DESCRIPTION
c   This routine updates the sulfur chemistry.
c
c ARGUMENTS
c   chemintv    : chemistry time step (s)
c   londeg      : longitude (deg)
c   latdeg      : latitude  (deg)
c   kel         : temperature (degK)
c   const       : species concentration, known at zone centers (mixing ratio)
c   humidity    : specific humidity  (g/kg)
c   emiss       : array of emissions (kg/s)
c   mcor        : area of grid box   (m^2)
c   qjimp       : photolysis rate constants (s^-1)
c   qkimp       : thermal    rate constants (units vary)
c   moistq      : moisture changes due to wet processes (g/kg/day)
c   cmf1        : convective mass flux used for cloud fraction calculation
c                 (kg/m^2/s)
c   press3c     : atmospheric pressure at the center of each grid box (mb)
c   grid_height : height of each grid box (m)
c   mass        : total mass of the atmosphere within each grid box (kg)
c   dms_oh      : SO2 production from DMS + OH  accumulated since last output
c                 used for sulfur budget (kg)
c   dms_no3     : SO2 production from DMS + NO3 accumulated since last output
c                 used for sulfur budget (kg)
c   so2_oh      : SO4 production from SO2 + OH  accumulated since last output
c                 used for sulfur budget (kg)
c   so2_h2o2    : SO4 production from SO2 + H2O2 (aqueous phase) accumulated
c                 since last output used for sulfur budget (kg)
c   so2_o3      : SO4 production from SO2 + O3   (aqueous phase) accumulated
c                 since last output used for sulfur budget (kg)
c   so2_hete    : SO4 production from SO2 heter. reactions on dust/sea salt
c                 accumulated since last output used for sulfur budget (kg)
c   clwc2       : in cloud liquid water content from CAM5 (g/g) !added by Cheng Zhou
c   ran_cloud       : total cloud fraction from CAM5  !added by Cheng Zhou
c-----------------------------------------------------------------------------

c change note by Cheng Zhou
c  1) include imp_dims.h is replaced by use h_imp_dims
c  2) include imp_control.h is replaced by use h_imp_control
c  3) include imp_gen_io.h is replaced by use h_imp_gen_io
c  4) imon is always set to 1, we will use udpated emission from CAM5 at each step
c  5) do not call Do_Sulf_Init, qjimp will be dealt late, now just use input value.

      subroutine Update_Sulfchem
     &  (chemintv, londeg, latdeg, kel, const, humidity, emiss, mcor,
     & qjimp, qkimp, moistq, cmf1, press3c, grid_height,ispb, mass,
     & dms_oh, dms_no3, so2_oh, so2_h2o2, so2_o3, so2_hete,
     & clwc2,ran_cloud,ncol,lchnk)

      use h_imp_dims, only: i1_gl, i2_gl,ju1_gl,j2_gl, ilo,ihi,julo,jhi,
     &k1,k2,i1,i2, ju1,j2,
     &num_emiss, emiss_timpyr,num_qjs,num_qks,num_species,num_molefrac,
     &loc_proc, pr_diag
     
      use h_imp_control, only: imgas_num,do_clear_sky,nymd,nhms,
     &mw,emiss_map, num_time_steps
      
      use h_imp_gen_io, only: pr_sulf_src,aqua_infile_name
      
      use h_imp_time_constants
      use h_imp_phys_constants
      use h_setkin_par
      use h_setkin_depos
      
      implicit none

c#     include "imp_time_constants.h"
c#     include "imp_phys_constants.h"
c#     include "imp_dims.h"
c#     include "imp_control.h"
c#     include "imp_gen_io.h"
c#     include "setkin_par.h"
c#     include "setkin_depos.h"


c     ----------------------
c     Argument declarations.
c     ----------------------

      real*8  :: chemintv
      real*8  :: londeg  (ju1_gl:j2_gl)                 !passed to Do_Sulf_Solver directly
      real*8  :: latdeg  (ju1_gl:j2_gl)                !passed to Do_Sulf_Solver directly
      real*8  :: kel     (ilo:ihi, julo:jhi, k1:k2)    !used to cal RH, also passed to Do_Sulf_Solver directly
      real*8  :: const   (i1:i2, ju1:j2, k1:k2, num_species) ! changed unit from kg/kg to #/cm3 for gas, pass to solver, change unit back to kg/kg
      real*8  :: humidity(i1:i2, ju1:j2, k1:k2)        !used to cal RH, also passed
      real*8  :: emiss   (i1:i2, ju1:j2, k1:k2, num_emiss)!used to cal sulf_emiss, not passed
      real*8  :: mcor    (i1:i2, ju1:j2)                 ! used to cal sulf_emiss, not passed
      real*8  :: qjimp   (i1:i2, ju1:j2, k1:k2, num_qjs) ! num_qjs=NUM_J=1 (setkin_par.h) it is not input argument but ouput. In chem_update.F/Update_Sulfchem/Do_sulf_init,  qjh2o2_2d2x5_R8.nc is read into  qjh2o2_2d, late in sulfchem_solver.F, it is interpolated and  set qjimp 
      real*8  :: qkimp   (i1:i2, ju1:j2, k1:k2, num_qks) ! num_qks=NUM_K=8 (setkin_par.h), ouput
      real*8  :: moistq  (i1:i2, ju1:j2, k1:k2)          !! NOT used even in original case
      real*8  :: cmf1    (i1:i2,  ju1:j2, k1:k2)         !! cmf is used to calculate cumulus cloud fraction, not used anymore
      real*8  :: press3c (ilo:ihi, julo:jhi, k1:k2)      !used for RH, also passed.
      real*8  :: grid_height(i1:i2, ju1:j2, k1:k2)       !used to cal sulf_emiss, not passed.
      integer :: ispb    (i1:i2, ju1:j2, k1:k2)       !the flag for boundary layer: 1, yes; 0: no 
      real*8  :: mass    (i1:i2, ju1:j2, k1:k2)          !passed to Do_Sulf_Solver directly
      real*8  :: dms_oh  (i1:i2, ju1:j2, k1:k2)
      real*8  :: dms_no3 (i1:i2, ju1:j2, k1:k2)
      real*8  :: so2_oh  (i1:i2, ju1:j2, k1:k2)
      real*8  :: so2_h2o2(i1:i2, ju1:j2, k1:k2)
      real*8  :: so2_o3  (i1:i2, ju1:j2, k1:k2)
      real*8  :: so2_hete(i1:i2, ju1:j2, k1:k2)
      real*8  :: clwc2   (i1:i2, ju1:j2, k1:k2) !added by Cheng Zhou
      real*8  :: ran_cloud  (i1:i2, ju1:j2, k1:k2) ! added by Cheng Zhou
      integer :: ncol,lchnk   
c     -----------------------
c     Parameter declarations.
c     -----------------------

      real*8, parameter :: CMPM3 = CMPM * CMPM * CMPM


c     ----------------------
c     Variable declarations.
c     ----------------------

      logical, save :: first = .true.

      integer :: il, ij, ik
      integer :: ic, icx
      integer :: idumday, idumyear
      integer :: imon
      integer :: month

      real*8  :: fac

      real*8  :: conv_emiss(i1:i2, ju1:j2, k1:k2)
      real*8  :: sulf_emiss(i1:i2, ju1:j2, k1:k2, num_species)



c     -----------------------------------------------------
c     clfrac : total cloud fraction [0 - 1]
c     lwccol : in-cloud liquid water in each grid box (g/g)
c     relhum : relative humidity [0 - 1]
c     -----------------------------------------------------

      real*8, allocatable :: clfrac (:,:,:)
      real*8, allocatable :: lwccol (:,:,:)
      real*8, allocatable :: relhum (:,:,:)
     

c     ----------------
c     Begin execution.
c     ----------------
 
      if (pr_diag) then
        Write (6,*) 'Update_Sulfchem called by ', loc_proc
      end if


      Allocate (clfrac (i1:i2, ju1:j2, k1:k2))
      clfrac = 0.0d0

      Allocate (lwccol (i1:i2, ju1:j2, k1:k2))
      Allocate (relhum (i1:i2, ju1:j2, k1:k2))
      lwccol = 0.0d0; relhum = 0.0d0
      


      if (first) then

        first = .false.

        if (pr_sulf_src) then
          dms_oh  (:,:,:) = 0.0d0
          dms_no3 (:,:,:) = 0.0d0

          so2_oh  (:,:,:) = 0.0d0
          so2_h2o2(:,:,:) = 0.0d0
          so2_o3  (:,:,:) = 0.0d0
          so2_hete(:,:,:) = 0.0d0
        end if

cc       =================
c        call Do_Sulf_Init
cc       =================
c     &    (pr_diag, loc_proc, j2_gl, qj_infile_name, qj_var_name)./c

      end if


c     -----------------------------------------------------------
c     Calculate relative humidity from Seinfeld (1986) p. 181.
c     The first rh is the temperature dependent parameter a.
c     The second rh is the saturation vapor pressure of water.
c     The third rh is the actual relative humidity as a fraction.
c     Then make sure rh is between 0 and 0.95.
c     -----------------------------------------------------------

      do ij = ju1, j2
        do il = i1, i2

          relhum(il,ij,:) =
     &      1.0d0 - (373.15d0 / kel(il,ij,:))

          relhum(il,ij,:) =
     &      1013.25d0 * Exp (13.3185d0 * relhum(il,ij,:)    -
     &                        1.9760d0 * relhum(il,ij,:)**2 -
     &                        0.6445d0 * relhum(il,ij,:)**3 -
     &                        0.1299d0 * relhum(il,ij,:)**4)

          relhum(il,ij,:) =
     &      humidity(il,ij,:) * MWTAIR / 18.0d0 / GPKG *
     &      press3c(il,ij,:) / relhum(il,ij,:)

          relhum(il,ij,:) =
     &      Max (Min (relhum(il,ij,:), 0.95d0), 0.0d0)

        end do
      end do


c     ======================
      if (do_clear_sky) then
c     ======================

        clfrac(:,:,:) = 0.0d0
        lwccol(:,:,:) = 0.0d0

c     ====
      else
c     ====

c     write(*,*) maxval(lwccol),maxval(clwc2)
      lwccol(:,:,:) = clwc2(:,:,:) !added by Cheng Zhou, use in cloud liquid water content from CAM5 
      clfrac(:,:,:) = ran_cloud(:,:,:) !added by Cheng Zhou, total cloud fraction from CAM5 
      
c     ======
      end if
c     ======

     
c     ------------------------------------------------
c     Change units from mixing ratio to concentration. (#/cm^3)
c     (only for gas-species, not for aerosols).
c     ------------------------------------------------

      do ic = 1, num_molefrac

        if (aerosol(ic) <= 0) then
          const(i1:i2,ju1:j2,:,ic) =
     &      const(i1:i2,ju1:j2,:,ic) *
     &      const(i1:i2,ju1:j2,:,imgas_num)
        end if

      end do

cc set imon to 1 all the time
c      if (emiss_timpyr == MONTHS_PER_YEAR) then
c        call Split_Time_Flds (nymd, idumyear, month, idumday)
c        imon = month
c      else
!        imon = 1
c      end if


c     --------------------------------------------------------------------
c     Calculate conversion factor to go from kg/box/s to molecules/cm^3/s,
c     but leave out the molecular weight term for each species.
c     --------------------------------------------------------------------

!      fac = AVOGAD * GPKG
!
!      do ik = k1, k2
!        conv_emiss(:,:,ik) =
!     &    fac / mcor(:,:) / CMPM3 / grid_height(:,:,ik)
!      end do
!
!
!c     --------------------------------------------------------------
!c     Now do the conversion for each sulfur species that is emitted.
!c     --------------------------------------------------------------
!
!      sulf_emiss(:,:,:,:) = 0.0d0
!
!      do icx = 1, num_emiss
!
!        ic = emiss_map(icx)
!
!        if ((ic == IFSO2) .or. (ic == INSO2) .or. (ic == INDMS)) then
!          sulf_emiss(:,:,:,ic) =
!     &      emiss(:,:,:,icx,imon) * conv_emiss(:,:,:) / mw(ic)
!        end if
!
!      end do

      sulf_emiss(:,:,:,:) = 0.0d0
      do icx = 1, num_emiss

        ic = emiss_map(icx)

        if ((ic == IFSO2) .or. (ic == INSO2) .or. (ic == INDMS)) then !need to deal with aSO2 and emiss map
          sulf_emiss(:,:,:,ic) = emiss(:,:,:,icx) 
        end if

      end do     
      
c     ===================
      call Do_Sulf_Solver
c     ===================
     &  (chemintv, nymd, nhms, kel(i1:i2,ju1:j2,k1:k2), 
     &   press3c(i1:i2,ju1:j2,k1:k2), ispb(i1:i2, ju1:j2, k1:k2), const, humidity, 
     &   sulf_emiss, qjimp, qkimp, clfrac, lwccol, relhum, 
     &   aqua_infile_name, num_time_steps, londeg, latdeg, mass,
     &   pr_sulf_src, dms_oh, dms_no3, so2_oh, so2_h2o2, so2_o3,
     &   grid_height,ncol,lchnk)


c     ----------------------------------------------------
c     Change units from concentration (#/cm^3) back to volume mixing ratio (#/#)
c     (only for gas-species).
c     ----------------------------------------------------

      do ic = 1, num_molefrac
        if (aerosol(ic) <= 0) then
          const(i1:i2,ju1:j2,:,ic) =
     &      const(i1:i2,ju1:j2,:,ic) /
     &      const(i1:i2,ju1:j2,:,imgas_num)
        end if
      end do

      Deallocate (clfrac)
      Deallocate (lwccol)
      Deallocate (relhum)

      return

      end
 
