      subroutine diaginit(nbox,icase,ilevel,imonth,iout)
#ifdef DIAG
c
c---->lay out storage for diagnostic quantities
c     explained in module modiag_umaer
c
c---->load modules
c
      use precision
      use modpar_umaer
      use modbox_umaer
      use modiag_umaer
c
c---->define accuracy
c
      implicit real(kdef) (a-h,o-z), integer (i-n)
c
c---->define local arrays and parameter
c
      parameter (nlevel=4,nmonth=2)
      dimension level(nlevel)
      save level
      data level /50,200,500,850/
      character*50 outfile
      character*3 cmonth(nmonth)
      save cmonth
      data cmonth /'jan','jul'/
c
c---->allocate memory for module modiag_umaer
c
      allocate(so4nucn(nbox),so4nucm(nbox),
     $         so4con (nbox),so4conn(nbox),
     $         so4coag(nbox),so4coagn(nbox),
     $         so4grvn(nbox),so4grvm(nbox),
     $         begnuc(2,nbox),stat=istat)

      if (istat<0) then
         print*,'DIAGINIT: Could not allocate memory:',istat
         stop
      endif
c
c---->preset diagnostic quantities
c
      so4nucn(1:nbox)=r0
      so4nucm(1:nbox)=r0
      so4con (1:nbox)=r0
      so4conn(1:nbox)=r0
      so4coag(1:nbox)=r0
      so4coagn(1:nbox)=r0
      so4grvn(1:nbox)=r0
      so4grvm(1:nbox)=r0
      begnuc(1:2,1:nbox)=1.d30
c
c---->open output file 
c
#ifndef JOHN
      write(outfile,200) icase,cmonth(imonth),level(ilevel)
      open(iout,file=outfile)
      write(outfile,201) icase,cmonth(imonth),level(ilevel)
      open(iout+1,file=outfile)
      write(iout,100) 'umaer','jan',real(level(ilevel),kdef)
      return
 100  format('# model name: ',a5,
     $       ', month= ',a3,', pressure= ',f5.0,'mb',/,
     $       '#  iden',5x,'time',9x,'so4gas ',6x,'so4mas ',6x,
     $       'so4num ',6x,'so4num0',6x,'so4num1',6x,'so4num2',6x,
     $       'so4num3',6x,'so4area',6x,'so4nucn',6x,'so4nucm',6x,
     $       'so4con ',6x,'so4coag',6x,'so4grvn',6x,'so4grvm',6x,
     $       'radvol1',6x,'numbin1',6x,'radvol2',6x,'numbin2',6x,
     $       'radvol3',6x,'numbin3')
 200  format('umaer_case',i1,'_',a3,'_',i3.3,'mb.dat')
 201  format('umaer_onset_case',i1,'_',a3,'_',i3.3,'mb.dat')
#else
      outfile='johns_test.dat'
      open(iout,file=outfile)
      write(iout,100)
      return
 100  format('#  iden',5x,'time',9x,'so4gas ',6x,'so4mas ',6x,
     $       'so4num ',6x,'so4num1',6x,'so4num2',6x,'so4num3',6x,
     $       'so4area',6x,'so4nucn',6x,'so4nucm',6x,'so4con ',6x,
     $       'so4coag',6x,'so4grvn',6x,'so4grvm')
#endif
      end
c-----------------------------------------------------------------------
      subroutine diagreset(nbox)
c
c---->reset diagnostic quantities
c
c---->load modules
c
      use precision
      use modpar_umaer
      use modiag_umaer
c
c---->define accuracy
c
      implicit real(kdef) (a-h,o-z), integer (i-n)
c
c---->reset diagnostic quantities
c
      so4nucn(1:nbox)=r0
      so4nucm(1:nbox)=r0
      so4con (1:nbox)=r0
      so4conn(1:nbox)=r0
      so4coag(1:nbox)=r0
      so4coagn(1:nbox)=r0
      so4grvn(1:nbox)=r0
      so4grvm(1:nbox)=r0
      begnuc(1:2,1:nbox)=1.d30

      return
      end
c-----------------------------------------------------------------------
      subroutine diagclean
c
c---->clean storage for diagnostic quantities
c
c---->load modules
c
      use precision
      use modiag_umaer
c
c---->define accuracy
c
      implicit real(kdef) (a-h,o-z), integer (i-n)
c
c---->deallocate memory for module modiag_umaer
c
      deallocate(so4nucn,so4nucm,
     $           so4con ,so4conn,so4coag,so4coagn,
     $           so4grvn,so4grvm,begnuc,stat=istat)

      if (istat<0) then
         print*,'DIAGCLEAN: Could not deallocate memory:',istat
         stop
      endif

      end
c-----------------------------------------------------------------------
      subroutine diagfill(ivec,ibox)
c
c---->store diagnostic quantities for iteration
c
c
c---->load modules
c
      use precision
      use modbox_umaer
      use modiag_umaer
c
c---->define accuracy
c
      implicit real(kdef) (a-h,o-z), integer (i-n)
c
c---->store diagnostic quantities for iteration
c
      xnucn(ivec)=so4nucn(ibox)
      xnucm(ivec)=so4nucm(ibox)
      xcon (ivec)=so4con (ibox)
      xconn(ivec)=so4conn(ibox)
      xcoag(ivec)=so4coag(ibox)
      xcoagn(ivec)=so4coagn(ibox)
      xgrvn(ivec)=so4grvn(ibox)
      xgrvm(ivec)=so4grvm(ibox)
      xbeg(1:2,ivec)=begnuc(1:2,ibox)
      
      end
c-----------------------------------------------------------------------
      subroutine diagrefill(ivec,ibox)
c
c---->restore diagnostic quantities for iteration
c
c
c---->load modules
c
      use precision
      use modbox_umaer
      use modiag_umaer
c
c---->define accuracy
c
      implicit real(kdef) (a-h,o-z), integer (i-n)
c
c---->restore diagnostic quantities for iteration
c
      so4nucn(ibox)=xnucn(ivec)
      so4nucm(ibox)=xnucm(ivec)
      so4con (ibox)=xcon (ivec)
      so4conn(ibox)=xconn(ivec)
      so4coag(ibox)=xcoag(ivec)
      so4coagn(ibox)=xcoagn(ivec)
      so4grvn(ibox)=xgrvn(ivec)
      so4grvm(ibox)=xgrvm(ivec)
      begnuc(1:2,ibox)=xbeg(1:2,ivec)
      
      end
c-----------------------------------------------------------------------
      subroutine diagshift(ivec,jvec)
c
c---->shift diagnostic quantities
c
c
c---->load modules
c
      use precision
      use modbox_umaer
c
c---->define accuracy
c
      implicit real(kdef) (a-h,o-z), integer (i-n)
c
c---->shift diagnostic quantities
c
      xnucn(ivec)=xnucn(jvec)
      xnucm(ivec)=xnucm(jvec)
      xcon (ivec)=xcon (jvec)
      xconn(ivec)=xconn(jvec)
      xcoag(ivec)=xcoag(jvec)
      xcoagn(ivec)=xcoagn(jvec)
      xgrvn(ivec)=xgrvn(jvec)
      xgrvm(ivec)=xgrvm(jvec)
      xbeg(1:2,ivec)=xbeg(1:2,jvec)

      end
c-----------------------------------------------------------------------
      subroutine diagpoint(nv,ix,ifx)
c
c---->set pointer for storage of diagnostic quantities and derivatives
c     and reset arrays
c
c---->load modules
c
      use precision
      use modpar_umaer
      use modbox_umaer
c
c---->define accuracy
c
      implicit real(kdef) (a-h,o-z), integer (i-n)

      if (ix==1 .or. ix==2) then
         dxnucn => dynucn(1:nv,ix)
         dxnucm => dynucm(1:nv,ix)
         dxcon  => dycon (1:nv,ix)
         dxconn => dyconn(1:nv,ix)
         dxcoag => dycoag(1:nv,ix)
         dxcoagn=> dycoagn(1:nv,ix)
         dxgrvn => dygrvn(1:nv,ix)
         dxgrvm => dygrvm(1:nv,ix)

         dynucn(1:nv,ix)=r0
         dynucm(1:nv,ix)=r0
         dycon (1:nv,ix)=r0
         dyconn(1:nv,ix)=r0
         dycoag(1:nv,ix)=r0
         dycoagn(1:nv,ix)=r0
         dygrvn(1:nv,ix)=r0
         dygrvm(1:nv,ix)=r0
      endif

      if (ifx>=1 .and. ifx<=3) then
         fxnucn => fynucn(1:nv,ifx)
         fxnucm => fynucm(1:nv,ifx)
         fxcon  => fycon (1:nv,ifx)
         fxconn => fyconn(1:nv,ifx)
         fxcoag => fycoag(1:nv,ifx)
         fxcoagn=> fycoagn(1:nv,ifx)
         fxgrvn => fygrvn(1:nv,ifx)
         fxgrvm => fygrvm(1:nv,ifx)
      endif

      end
c-----------------------------------------------------------------------
      subroutine diagadd(nv,ifx,ify)
c
c---->add derivatives fy(ifx)=fy(ifx)+fy(ify)
c
c---->load modules
c
      use precision
      use modpar_umaer
      use modbox_umaer
c
c---->define accuracy
c
      implicit real(kdef) (a-h,o-z), integer (i-n)


      if (ifx>=1 .and. ifx<=3 .and.
     $    ify>=1 .and. ify<=3) then
         fynucn(1:nv,ifx)=fynucn(1:nv,ifx)+fynucn(1:nv,ify)
         fynucm(1:nv,ifx)=fynucm(1:nv,ifx)+fynucm(1:nv,ify)
         fycon (1:nv,ifx)=fycon (1:nv,ifx)+fycon (1:nv,ify)
         fyconn(1:nv,ifx)=fyconn(1:nv,ifx)+fyconn(1:nv,ify)
         fycoag(1:nv,ifx)=fycoag(1:nv,ifx)+fycoag(1:nv,ify)
         fycoagn(1:nv,ifx)=fycoagn(1:nv,ifx)+fycoagn(1:nv,ify)
         fygrvn(1:nv,ifx)=fygrvn(1:nv,ifx)+fygrvn(1:nv,ify)
         fygrvm(1:nv,ifx)=fygrvm(1:nv,ifx)+fygrvm(1:nv,ify)
      endif

      end
c-----------------------------------------------------------------------
      subroutine diagstore(nv,ifx)
c
c---->store derivative
c
c---->load modules
c
      use precision
      use modpar_umaer
      use modbox_umaer
c
c---->define accuracy
c
      implicit real(kdef) (a-h,o-z), integer (i-n)

      if (ifx>=1 .and. ifx<=3) then
         fsavenucn(1:nv)=fynucn(1:nv,ifx)
         fsavenucm(1:nv)=fynucm(1:nv,ifx)
         fsavecon (1:nv)=fycon (1:nv,ifx)
         fsaveconn(1:nv)=fyconn(1:nv,ifx)
         fsavecoag(1:nv)=fycoag(1:nv,ifx)
         fsavecoagn(1:nv)=fycoagn(1:nv,ifx)
         fsavegrvn(1:nv)=fygrvn(1:nv,ifx)
         fsavegrvm(1:nv)=fygrvm(1:nv,ifx)
      endif

      end
c-----------------------------------------------------------------------
      subroutine diagrestore(nv,ifx)
c
c---->restore derivative
c
c---->load modules
c
      use precision
      use modbox_umaer
c
c---->define accuracy
c
      implicit real(kdef) (a-h,o-z), integer (i-n)

      if (ifx>=1 .and. ifx<=3) then
         fynucn(1:nv,ifx)=fsavenucn(1:nv)
         fynucm(1:nv,ifx)=fsavenucm(1:nv)
         fycon (1:nv,ifx)=fsavecon (1:nv)
         fyconn(1:nv,ifx)=fsaveconn(1:nv)
         fycoag(1:nv,ifx)=fsavecoag(1:nv)
         fycoagn(1:nv,ifx)=fsavecoagn(1:nv)
         fygrvn(1:nv,ifx)=fsavegrvn(1:nv)
         fygrvm(1:nv,ifx)=fsavegrvm(1:nv)
      endif

      end
c-----------------------------------------------------------------------
      subroutine diagchange(nv,dt)
c
c---->update changes of diagnostic quantities
c
c---->load modules
c
      use precision
      use modpar_umaer
      use modbox_umaer
c
c---->define accuracy, input arrays
c
      implicit real(kdef) (a-h,o-z), integer (i-n)
      dimension dt(nv)

      dxnucn(1:nv)=dxnucn(1:nv)
     $     +dt(1:nv)*(fynucn(1:nv,1)+r2*fynucn(1:nv,2)+fynucn(1:nv,3))
      dxnucm(1:nv)=dxnucm(1:nv)
     $     +dt(1:nv)*(fynucm(1:nv,1)+r2*fynucm(1:nv,2)+fynucm(1:nv,3))
      dxcon (1:nv)=dxcon (1:nv)
     $     +dt(1:nv)*(fycon (1:nv,1)+r2*fycon (1:nv,2)+fycon (1:nv,3))
      dxconn(1:nv)=dxconn(1:nv)
     $     +dt(1:nv)*(fyconn(1:nv,1)+r2*fyconn(1:nv,2)+fyconn(1:nv,3))
      dxcoag(1:nv)=dxcoag(1:nv)
     $     +dt(1:nv)*(fycoag(1:nv,1)+r2*fycoag(1:nv,2)+fycoag(1:nv,3))
      dxcoagn(1:nv)=dxcoagn(1:nv)
     $  +dt(1:nv)*(fycoagn(1:nv,1)+r2*fycoagn(1:nv,2)+fycoagn(1:nv,3))
      dxgrvn(1:nv)=dxgrvn(1:nv)
     $     +dt(1:nv)*(fygrvn(1:nv,1)+r2*fygrvn(1:nv,2)+fygrvn(1:nv,3))
      dxgrvm(1:nv)=dxgrvm(1:nv)
     $     +dt(1:nv)*(fygrvm(1:nv,1)+r2*fygrvm(1:nv,2)+fygrvm(1:nv,3))

      end
c-----------------------------------------------------------------------
      subroutine diagupdate(time,dt,iv,iflg)
c
c---->update diagnostic quantities
c
c---->load modules
c
      use precision
      use modpar_umaer
      use modbox_umaer
c
c---->define accuracy
c
      implicit real(kdef) (a-h,o-z), integer (i-n)
c
c---->define local parameter
c
      parameter (r1h=0.5d0)
      parameter (fcor=1.d0/15.d0)

      xnucnold=xnucn(iv)

      if (iflg/=0) then
       xnucn(iv)=xnucn(iv)+max(r0,dynucn(iv,1)
     $              +fcor*(dynucn(iv,1)-dynucn(iv,2)))
       xnucm(iv)=xnucm(iv)+max(r0,dynucm(iv,1)
     $              +fcor*(dynucm(iv,1)-dynucm(iv,2)))
       xcon (iv)=xcon (iv)+max(r0,dycon (iv,1)
     $              +fcor*(dycon (iv,1)-dycon (iv,2)))
       xconn(iv)=xconn(iv)+max(r0,dyconn(iv,1)
     $              +fcor*(dyconn(iv,1)-dyconn(iv,2)))
       xcoag(iv)=xcoag(iv)+min(r0,dycoag(iv,1)
     $              +fcor*(dycoag(iv,1)-dycoag(iv,2)))
       xcoagn(iv)=xcoagn(iv)+min(r0,dycoagn(iv,1)
     $              +fcor*(dycoagn(iv,1)-dycoagn(iv,2)))
       xgrvn(iv)=xgrvn(iv)+min(r0,dygrvn(iv,1)
     $              +fcor*(dygrvn(iv,1)-dygrvn(iv,2)))
       xgrvm(iv)=xgrvm(iv)+min(r0,dygrvm(iv,1)
     $              +fcor*(dygrvm(iv,1)-dygrvm(iv,2)))
      else
       xnucn(iv)=xnucn(iv)+dynucn(iv,1)
       xnucm(iv)=xnucm(iv)+dynucm(iv,1)
       xcon (iv)=xcon (iv)+dycon (iv,1)
       xconn(iv)=xconn(iv)+dyconn(iv,1)
       xcoag(iv)=xcoag(iv)+dycoag(iv,1)
       xcoagn(iv)=xcoagn(iv)+dycoagn(iv,1)
       xgrvn(iv)=xgrvn(iv)+dygrvn(iv,1)
       xgrvm(iv)=xgrvm(iv)+dygrvm(iv,1)
      endif

      xlim=1.d8
      if (xnucnold<xlim .and. xnucn(iv)>=xlim) then
       slope=dt/(xnucn(iv)-xnucnold)
       xintc=((time-dt)*xnucn(iv)-time*xnucnold)
     $      /(xnucn(iv)-xnucnold)
       xbeg(1,iv)=xintc+slope*xlim
       xbeg(2,iv)=r1h*dt
      endif

      end
c-----------------------------------------------------------------------
      subroutine writedata(iden,nbox,
     $                     temp,press,relhum,cldfrac,
     $                     so4gas,so4aer,so4non,aernon,sigmod,time,iout)
c
c---->write output data
c
c
c---->load modules
c
      use precision
      use modpar_umaer
      use modiag_umaer
      use modinit_umaer
c
c---->define accuracy
c
      implicit real(kdef) (a-h,o-z), integer (i-n)
c
c---->define arrays and parameter
c
      dimension iden(nbox)
      dimension temp(nbox),press(nbox),relhum(nbox),cldfrac(nbox)
      dimension so4gas(nbox),so4aer(nmomso4,nso4,nbox)
      dimension so4non(nnon,nbox),aernon(nmomnon,nnon,nbox)
      dimension sigmod(nso4)

      dimension radv(nso4)

      parameter (r4=4.d0,r3h=1.5d0,r3q=0.75d0,r1td=1.d0/3.d0)
      parameter (tscale=1.d0/3600.d0)
      parameter (nsize=3)
      dimension so4num(nsize),radlim(nsize)

      radlim(1:nsize)=(/0.005d-6,0.05d-6,0.5d-6/)
c
c---->calculate initial derivatives
c
      if (time==r0) then
       call initderiv(nbox,temp,press,relhum,cldfrac,
     $                   so4gas,so4aer,so4non,aernon)
      endif
c
c---->start loop over boxes
c
      do ibox=1,nbox
c
c---->calculate aerosol properties
c
       so4num(:)=r0
       so4area=r0
       do iso4=1,nso4

        iinv=nso4-iso4+1

        h2osat=h2osat_f(temp(ibox))
        h2ogas=relhum(ibox)*h2osat

        so4mfrac=so4mfrac_f(temp(ibox),h2osat,h2ogas)
        so4dens=so4dens_f(temp(ibox),so4mfrac)
        wetmas=max(r2,so4aer(1,iso4,ibox)
     $        /max(epsilon,so4aer(2,iso4,ibox)))
     $        *so4min/so4mfrac
        radv(iso4)=(r3q*wetmas/(pi*so4dens))**r1td
        radg=radv(iso4)*exp(-r3h*log(sigmod(iso4))**2)
c
c---->calculate fractional number concentrations
c
        do isize=1,nsize
         so4num(isize)=so4num(isize)+so4aer(2,iso4,ibox)
     $                *fracdiag_f(radg,sigmod(iso4),radlim(isize))
        enddo
c
c---->calculate total sulfate aerosol surface area
c
        so4area=so4area+r4*pi*radg*radg
     $         *exp(r2*log(sigmod(iso4))**2)*so4aer(2,iso4,ibox)
       enddo

       so4num_tot=sum(so4aer(2,:,ibox))

#ifdef NONON
       write(iout,110) iden(ibox),time*tscale,so4gas(ibox),
     $              sum(so4aer(1,:,ibox)),so4num_tot,
     $              so4num_tot-so4num(1),
     $              so4num(1),so4num(2),so4num(3),
     $              so4area,so4nucn(ibox),so4nucm(ibox),
     $              so4con(ibox),so4coag(ibox),
     $              so4grvn(ibox),so4grvm(ibox),
     $              (radv(iso4),so4aer(2,iso4,ibox),iso4=1,nso4)
#else
       write(iout,110) iden(ibox),time*tscale,so4gas(ibox),
     $              sum(so4aer(1,:,ibox)),so4num_tot,
     $              so4num_tot-so4num(1),
     $              so4num(1),so4num(2),so4num(3),
     $              so4area,so4nucn(ibox),so4nucm(ibox),
     $              so4con(ibox),so4coag(ibox),
     $              so4grvn(ibox),so4grvm(ibox),
     $              (radv(iso4),so4aer(2,iso4,ibox),iso4=1,nso4),
     $              (so4non(inon,ibox),inon=1,nnon),
     $              so4conn(ibox),so4coagn(ibox)
#endif
      enddo

      return
 110  format(i10,35(1pe13.5))
      end
c-----------------------------------------------------------------------
      subroutine writedata_old(iden,nbox,
     $                     temp,press,relhum,cldfrac,
     $                     so4gas,so4aer,so4non,aernon,time,iout)
c
c---->write output data
c
c
c---->load modules
c
      use precision
      use modpar_umaer
      use modiag_umaer
      use modinit_umaer
c
c---->define accuracy
c
      implicit real(kdef) (a-h,o-z), integer (i-n)
c
c---->define arrays and parameter
c
      dimension iden(nbox)
      dimension temp(nbox),press(nbox),relhum(nbox),cldfrac(nbox)
      dimension so4gas(nbox),so4aer(nmomso4,nso4,nbox)
      dimension so4non(nnon,nbox),aernon(nmomnon,nnon,nbox)

      dimension sig(nso4),radv(nso4)

      parameter (r4=4.d0,r3h=1.5d0,r3q=0.75d0,r1td=1.d0/3.d0)
      parameter (tscale=1.d0/3600.d0)
      parameter (nsize=3)
      dimension so4num(nsize),radlim(nsize)

      radlim(1:nsize)=(/0.005d-6,0.05d-6,0.5d-6/)
c
c---->calculate sigma
c
      do ig=1,min(ng,nso4-1)
       iso4=ig
       sig(iso4)=siggso4(ig)
      enddo
      if (ng>nso4) then
       sigma=sum(fracso4(nso4:ng)*log(siggso4(nso4:ng))**2)
     $      /sum(fracso4(nso4:ng))
       sigma=exp(sqrt(sigma))
       sig(nso4)=sigma
      else
       sig(ng:nso4)=siggso4(ng)
      endif
c
c---->calculate initial derivatives
c
      if (time==r0) then
       call initderiv(nbox,temp,press,relhum,cldfrac,
     $                   so4gas,so4aer,so4non,aernon)
      endif
c
c---->start loop over boxes
c
      do ibox=1,nbox
c
c---->calculate aerosol properties
c
       so4num(:)=r0
       so4area=r0
       do iso4=1,nso4

        h2osat=h2osat_f(temp(ibox))
        h2ogas=relhum(ibox)*h2osat

        so4mfrac=so4mfrac_f(temp(ibox),h2osat,h2ogas)
        so4dens=so4dens_f(temp(ibox),so4mfrac)
        wetmas=max(r2,so4aer(1,iso4,ibox)
     $        /max(epsilon,so4aer(2,iso4,ibox)))
     $        *so4min/so4mfrac
        radv(iso4)=(r3q*wetmas/(pi*so4dens))**r1td
        radg=radv(iso4)*exp(-r3h*log(sig(iso4))**2)
c
c---->calculate fractional number concentrations
c
        do isize=1,nsize
         so4num(isize)=so4num(isize)+so4aer(2,iso4,ibox)
     $                *fracmerg_f(radg,sig(iso4),radlim(isize))
        enddo
c
c---->calculate total sulfate aerosol surface area
c
        so4area=so4area+r4*pi*radg*radg*exp(r2*log(sig(iso4))**2)
     $                *so4aer(2,iso4,ibox)
       enddo

       write(iout,110) iden(ibox),time*tscale,so4gas(ibox),
     $              sum(so4aer(1,:,ibox)),sum(so4aer(2,:,ibox)),
     $              so4num(1),so4num(2),so4num(3),
     $              so4area,so4nucn(ibox),so4nucm(ibox),
     $              so4con(ibox),so4coag(ibox),
     $              so4grvn(ibox),so4grvm(ibox),
     $              (radv(iso4),so4aer(2,iso4,ibox),iso4=1,nso4)

      enddo

      return
 110  format(i10,20(1pe13.5))
      end
c-----------------------------------------------------------------------
      subroutine initderiv(nbox,temp,press,relhum,cldfrac,
     $                     so4gas,so4aer,so4non,aernon)
c
c---->load modules
c
      use precision
      use modpar_umaer
      use modbox_umaer
      use modiag_umaer
c
c---->define accuracy and input/output arrays
c
      implicit real(kdef) (a-h,o-z), integer (i-n)
      dimension temp(nbox),press(nbox),relhum(nbox),cldfrac(nbox),
     $          so4gas(nbox),so4aer(nmomso4,nso4,nbox)
      dimension so4non(nnon,nbox),
     $          aernon(nmomnon,nnon,nbox)
c
c---->local arrays and parameter
c     xaer              temporary array for sulfate aerosol
c                       (all modes and moments)
c
      dimension xaer(nvec,nnon+nmomso4*nso4+1)
      dimension tempbox(nvec),pressbox(nvec),relhumbox(nvec)

      parameter (r4=4.d0,r6=6.d0,r1td=1.d0/3.d0)
      parameter (a1=1.333d0,a2=0.71d0,b1=0.572127d0)
      parameter (c1=1.249d0,c2=0.42d0,c3=-0.87d0)
      parameter (rhmin=1.d-2,rhmax=0.99d0)
c
c---->declare interfaces
c
      interface
      subroutine setderiv(nv,temp,press,relhum,xaer)
      use precision
      use modpar_umaer
      use modbox_umaer
      implicit real(kdef) (a-h,o-z), integer (i-n)
      dimension temp(nv),press(nv),relhum(nv)
      dimension xaer(nvec,ntot)
      target xaer
      end subroutine setderiv
      end interface
c
c---->set pointer for diagnostics
c
      nv=min(nvec,nbox)
      call diagpoint(nv,1,1)
c
c---->start loop over boxes
c
      do iv=1,nv
       ibox=iv
c
c---->store sulfate stuff
c
       xaer(iv,1:nnon)=so4non(1:nnon,ibox)
       do iso4=1,nso4
        do imom=1,nmomso4
         iaer=ntot-(iso4-1)*nmomso4-nmomso4+imom-1
         xaer(iv,iaer)=so4aer(imom,iso4,ibox)
        enddo
       enddo
       xaer(iv,ntot)=so4gas(ibox)
c
c---->store non-so4 aerosol number concentrations       [#part/m3]
c
       xnonum(iv,1:nnon)=aernon(1,1:nnon,ibox)/pmsnon(1:nnon)
c
c---->store meteorological data and sources
c
       tempbox(iv)=temp(ibox)
       pressbox(iv)=press(ibox)
       relhumbox(iv)=max(rhmin,relhum(ibox))
c     
c---->the following quantities don't change during time integration
c     and are stored in common block /parcel/
c---->vapor pressures:
c     h2osat        h2o saturation pressure             [#molec/m3]
c     h2ogas        h2o gas concentration               [#molec/m3]
c     so4sat        h2so4 saturation pressure           [#molec/m3]
c
       h2osat(iv)=h2osat_f(temp(ibox))
       h2ogas(iv)=relhumbox(iv)*h2osat(iv)
       so4sat(iv)=so4sat_f(temp(ibox))
c
c---->aerosol composition and Kelvin effect:
c     so4mfrac      so4 mass fraction in aerosol        [1]
c     so4frac       so4 mole fraction in aerosol        [1]
c     so4dens       aerosol density                     [kg/m3]
c     so4kelvin     factor for Kelvin effect            [m]
c
       so4mfrac(iv)=so4mfrac_f(temp(ibox),h2osat(iv),
     $                                    h2ogas(iv))
       so4frac(iv)=so4mfrac(iv)*h2omol
     $           /(so4mfrac(iv)*h2omol+(r1-so4mfrac(iv))*so4mol)
       so4dens(iv)=so4dens_f(temp(ibox),so4mfrac(iv))

       so4kelvin(iv)=r2*so4sig_f(temp(ibox),so4frac(iv),so4mfrac(iv))
     $              *(so4frac(iv)*so4mol+(r1-so4frac(iv))*h2omol)
     $              /(rgas*temp(ibox)*so4dens(iv))
c
c---->rwetnon       humid volume mean radius            [m]
c     sea salt aerosol according to Gerber (1985) (<- Keith Grant)
c
       rhnew=max(rhmin,min(rhmax,relhum(ibox)))
       rwetnon(iv,1:nnon-4)=radvnon(1:nnon-4)
       rwetnon(iv,nnon-3:nnon)=(radvnon(nnon-3:nnon)**3
     $                    +crh1*radvnon(nnon-3:nnon)**crh2
     $                   /(crh3*radvnon(nnon-3:nnon)**crh4
     $                     -log10(rhnew)))**r1td
c
c---->Kelvin effect for non-sulfate aerosol
c     assuming that non-sulfate aerosol is completely coated with so4
c
       xnonkelvin(iv,1:nnon)=exp(so4kelvin(iv)
     $                            /rwetnon(iv,1:nnon))
c
c---->thermodynamic quantities:
c     pathair       mean free path of air               [m]
c     pathso4       mean free path of h2so4 in air      [m]
c     diffso4       diffusion coeff. for h2so4 in air   [m2/s]
c     viscos        dynamic viscosity of air            [Ns/m2]
c
       pathair(iv)=pathair_f(temp(ibox),press(ibox))
       pathso4(iv)=b1*pathair(iv)
       diffso4(iv)=r4*pi*diffso4_f(temp(ibox),press(ibox))
       viscos (iv)=viscos_f(temp(ibox))
#ifdef KULMALA
c
c---->quantities for nucleation:
c     so4crit       h2so4 conc with nuc' rate of 1/cm3  [#molec/m3]
c
       so4crit(iv)=so4crit_f(temp(ibox),relhum(ibox))
#else
       so4crit(iv)=r0
#endif
c
c---->quantities for condensation:
c     so4sol        h2so4 sat pressure over solution    [#molec/m3]
c     condnon       condensation coef's for non-so4 aer [m3/#molec]
c                   incl. correction for collision geometry
c                   following Fuchs and Sutugin (1971)
c
       so4sol(iv)=so4sol_f(temp(ibox),so4sat(iv),so4frac(iv))
       so4crit(iv)=max(r2*so4sol(iv),so4crit(iv))

       do inon=1,nnon
        xknu=pathso4(iv)/rwetnon(iv,inon)
        condnon(iv,inon)=diffso4(iv)*alphanon(inon)
     $                  /(r1+((a1*xknu+a2)/(r1+xknu)
     $                  +a1*(r1-etanon(inon))/etanon(inon))*xknu)
     $               *rwetnon(iv,inon)
       enddo
c
c---->quantities for coagulation
c
       do inon=1,nnon
        xknu=pathair(iv)/rwetnon(iv,inon)
        diffnon(iv,inon)=r4*boltz*temp(iv)
     $             /(r6*pi*viscos(iv)*rwetnon(iv,inon))
     $             *(r1+xknu*(c1+c2*exp(c3/xknu)))
       enddo
c
c---->quantities for merging:
c     pmsmerg       limit particle mass for merging     [#molec]
c
       do iso4=1,nso4
        pmsmerg(iv,iso4)=so4dens(iv)*so4mfrac(iv)*pmsfac(iso4)
       enddo
       pmsmerg(iv,nso4+1)=r2
      enddo
c
c---->set derivatives
c
      call setderiv(nv,temp,press,relhumbox,xaer)

      return
      end
c-----------------------------------------------------------------------
      subroutine setderiv(nv,temp,press,relhum,xaer)
c
c---->calculate initial time derivates (fxaer) and 
c     store in arrays for diagnostics
c
c
c---->load modules
c
      use precision
      use modpar_umaer
      use modbox_umaer
      use modiag_umaer
c
c---->define accuracy and input/output arrays
c
      implicit real(kdef) (a-h,o-z), integer (i-n)
      dimension xaer(nvec,ntot)
      dimension temp(nv),press(nv),relhum(nv)
      target xaer
c
c---->local arrays and parameter
c
      dimension fxaer(nv,ntot),dt(nv)
      dimension so4radv(nv,nso4),
     $          so4knu(nv,nso4),so4vel(nv,nso4)

      parameter (r8=8.d0,r3q=0.75d0,r1td=1.d0/3.d0)
c
c---->define pointer
c
      dimension so4non(:,:),so4aer(:,:),so4gas(:)
      pointer so4non,so4aer,so4gas
c
c---->set pointer
c
      so4non=>xaer(1:nvec,1:nnon)
      so4aer=>xaer(1:nvec,nnon+1:nnon+naer)
      so4gas=>xaer(1:nvec,ntot)
c
c---->initialize derivatives
c
      fxaer(1:nv,1:ntot)=r0
c
c---->calculate wet aerosol size (Tang and Munkelwitz (1994)),
c               Knudsen number,
c               (square of) characteristic velocity
c
      do iso4=1,nso4
       inum=iso4*nmomso4
       imas=inum-1
       do iv=1,nv
        wetmas=max(r2,so4aer(iv,imas)
     $        /max(epsilon/pmsmerg(iv,iso4+1),so4aer(iv,inum)))
     $        *so4min/so4mfrac(iv)
        so4vel (iv,iso4)=r8*boltz*temp(iv)/(pi*wetmas)
        so4radv(iv,iso4)=(r3q*wetmas/(pi*so4dens(iv)))**r1td
        so4knu (iv,iso4)=pathair(iv)/so4radv(iv,iso4)
       enddo
      enddo
      dt(1:nv)=r1
c
c---->nucleation
c
      call nucleation(nv,temp,relhum,so4gas,fxaer)
      so4nucn(1:nv)=fxnucn(1:nv)
      so4nucm(1:nv)=fxnucm(1:nv)
c
c---->condensation on so4 aerosol
c
      call condensso4(nv,so4gas,so4aer,so4radv,so4knu,dt,fxaer)
      so4con(1:nv)=fxcon(1:nv)
c
c---->condensation on non-so4 aerosol
c
#ifndef NONON
      call condensnon(nv,so4gas,so4non,dt,fxaer)
      so4conn(1:nv)=fxconn(1:nv)
#endif
c
c---->coagulation
c
      call coagulation(nv,temp,so4gas,so4aer,so4non,
     $                 so4radv,so4knu,so4vel,fxaer)
      so4coag(1:nv)=fxcoag(1:nv)
#ifndef NONON
      so4coagn(1:nv)=fxcoagn(1:nv)
#endif
#ifdef GRAV
c
c---->gravitational settling
c
      call settling(nv,so4aer,so4radv,fxaer)
      so4grvn(1:nv)=fxgrvn(1:nv)
      so4grvm(1:nv)=fxgrvm(1:nv)
#endif
#endif
      return
      end
c-----------------------------------------------------------------------
      function fracdiag_f(radg,sigma,radmrg)
c
c---->calculate integral over part of lognormal distribution
c     very similar to fracmerg_f in modinit_umaer.F
c     however, higher accuracy for diagnostic
c
c---->load modules
c
      use precision
      use modpar_umaer
c
c---->define accuracy
c
      implicit real(kdef) (a-h,o-z), integer (i-n)
c
c---->set local parameter
c
      parameter (r10=10.d0,r1h=0.5d0)
      parameter (dfrac=0.00005d0)

      if (sigma<=r1) then
       if (radg>radmrg) then
        fracdiag_f=r1
       else
        fracdiag_f=r0
       endif
      else
       xlnsg=log(sigma)
       xln2sg=xlnsg*xlnsg
       xln2sginv=-r1h/xln2sg

       if (radmrg<radg) then

        rscale=radg
        drad=dfrac*rscale*(r1-r1/sigma)
        sqr2pi=drad/(xlnsg*sqrt(r2*pi))

        fracdiag_f=r0
        radloc=radmrg-r1h*drad
        do while (radloc>r0)
         fracdiag_f=fracdiag_f
     $             +exp(xln2sginv*(log(radloc/radg))**2)/radloc
         radloc=radloc-drad
        enddo
        fracdiag_f=fracdiag_f*sqr2pi          

        fracdiag_f=r1-fracdiag_f

       else

        rscale=radmrg
        drad=dfrac*rscale*(r1-r1/sigma)
        sqr2pi=drad/(xlnsg*sqrt(r2*pi))

        fracdiag_f=r0
        radloc=radmrg+r1h*drad
        do while (radloc<r10*rscale)
         fracdiag_f=fracdiag_f
     $             +exp(xln2sginv*(log(radloc/radg))**2)/radloc
         radloc=radloc+drad
        enddo
        fracdiag_f=fracdiag_f*sqr2pi

       endif
      endif

      end function fracdiag_f
c-----------------------------------------------------------------------
