      module h_setkin_depos
      use h_setkin_par, only: NSP  !!extra when converting from .h to .F
      implicit none
      public 
c=======================================================================
c
c $Id: setkin_depos.h,v 1.3 2002/02/20 15:38:31 akinorii Exp $
c
c CODE DEVELOPER
c   Peter Connell, LLNL
c   connell2@llnl.gov
c
c   "setkin_depos.h" was modified by Xiaohong Liu
c
c FILE
c   setkin_depos.h
c
c DESCRIPTION
c   This include file contains physical information about each species which
c   will be used in the deposition routines. It includes an integer declaring
c   aerosol species (aerosol=1 means it is an aerosol, aerosol=0 means it is
c   a gas). There is also a Henry's law constant and oxidizing potential for
c   each species.
c
c  Chemistry input file generated: 2/23/00 10:12AM
c  Reaction dictionary:            3/29/99 2:55PM
c  Setkin files generated:         Wed Feb 23 10:30:41 2000
c
c=======================================================================

      integer      :: aerosol        (1:NSP)

      real*8, save :: hstar          (1:NSP)
      real*8, save :: oxidize        (1:NSP)
      real*8, save :: delH_298_over_R(1:NSP)
      real*8, save :: retention_eff  (1:NSP)

      data aerosol(1:NSP) /
     &  0,  0,  0,  0,  0,  1,  1,  2,  2,  3,  3,
     &  4,  5,  6,  7,  8,  5,  5,  6,  6,  9,  9,
     &  9,  9, 10, 11, 12, 13, 14, 15, 16, 17,
     &  4,  5,  6,  7,  8,  5,  5,  6,  6,  9,  9, 
     &  9,  9, 10, 11, 12, 13, 14, 15, 16, 17,
     &  0,  2,  0,  0,  0,  0,  0,  0 /

      data hstar(1:NSP) /
     & 1.00d5,    1.00d5,    1.00d5,    0.56d0,    1.00d9,
     & 0.00d0,    0.00d0,    0.00d0,    0.00d0,    0.00d0,
     & 0.00d0,    0.00d0,    0.00d0,    0.00d0,    0.00d0,
     & 0.00d0,    0.00d0,    0.00d0,    0.00d0,    0.00d0,
     & 0.00d0,    0.00d0,    0.00d0,    0.00d0,    0.00d0,
     & 0.00d0,    0.00d0,    0.00d0,    0.00d0,    0.00d0,    0.00d0,
     & 0.00d0,    0.00d0,    0.00d0,    0.00d0,    0.00d0,    0.00d0,
     & 0.00d0,    0.00d0,    0.00d0,    0.00d0,    0.00d0,    0.00d0,
     & 0.00d0,    0.00d0,    0.00d0,    0.00d0,    0.00d0,    0.00d0,
     & 0.00d0,    0.00d0,    0.00d0,    0.00d0,    1.00d5,    0.00d0,
     & 1.00d-2,   0.00d0,    0.00d0,    4.00d3,    2.00d0,    0.00d0 /

      data oxidize(1:NSP) /
     &    1.00d0,    0.00d0,    0.00d0,    0.00d0,    0.00d0,    
     &    0.00d0,    0.00d0,    0.00d0,    0.00d0,    0.00d0, 
     &    0.00d0,    0.00d0,    0.00d0,    0.00d0,    0.00d0,
     &    0.00d0,    0.00d0,    0.00d0,    0.00d0,    0.00d0,
     &    0.00d0,    0.00d0,    0.00d0,    0.00d0,    0.00d0,
     &    0.00d0,    0.00d0,    0.00d0,    0.00d0,    0.00d0,    0.00d0,
     &    0.00d0,    0.00d0,    0.00d0,    0.00d0,    0.00d0,    0.00d0,
     &    0.00d0,    0.00d0,    0.00d0,    0.00d0,    0.00d0,    0.00d0,
     &    0.00d0,    0.00d0,    0.00d0,    0.00d0,    0.00d0,    0.00d0,
     &    0.00d0,    0.00d0,    0.00d0,    0.00d0,    0.00d0,    0.00d0,
     &    1.00d0,    0.00d0,    0.00d0,    0.00d0,    1.00d0,    0.00d0 /

      data delH_298_over_R(1:NSP) /
     &-6.80d3, -3.02d3, -3.02d3,  0.00d0,  0.00d0,
     & 0.00d0,  0.00d0,  0.00d0,  0.00d0,  0.00d0,
     & 0.00d0,  0.00d0,  0.00d0,  0.00d0,  0.00d0,
     & 0.00d0,  0.00d0,  0.00d0,  0.00d0,  0.00d0,
     & 0.00d0,  0.00d0,  0.00d0,  0.00d0,  0.00d0,
     & 0.00d0,  0.00d0,  0.00d0,  0.00d0,  0.00d0,  0.00d0,
     & 0.00d0,  0.00d0,  0.00d0,  0.00d0,  0.00d0,  0.00d0,
     & 0.00d0,  0.00d0,  0.00d0,  0.00d0,  0.00d0,  0.00d0,
     & 0.00d0,  0.00d0,  0.00d0,  0.00d0,  0.00d0,  0.00d0,
     & 0.00d0,  0.00d0,  0.00d0,  0.00d0, -3.02d3,  0.00d0,
     & 2.30d3,  0.00d0,  0.00d0,  0.00d0,  0.00d0,  0.00d0 /

      data retention_eff(1:NSP) /
     & 0.05d0,  0.00d0,  0.00d0,  0.00d0,  0.00d0,
     & 0.00d0,  0.00d0,  0.00d0,  0.00d0,  0.00d0,
     & 0.00d0,  0.00d0,  0.00d0,  0.00d0,  0.00d0,
     & 0.00d0,  0.00d0,  0.00d0,  0.00d0,  0.00d0,
     & 0.00d0,  0.00d0,  0.00d0,  0.00d0,  0.00d0,
     & 0.00d0,  0.00d0,  0.00d0,  0.00d0,  0.00d0, 0.00d0,
     & 0.00d0,  0.00d0,  0.00d0,  0.00d0,  0.00d0, 0.00d0,
     & 0.00d0,  0.00d0,  0.00d0,  0.00d0,  0.00d0, 0.00d0,
     & 0.00d0,  0.00d0,  0.00d0,  0.00d0,  0.00d0, 0.00d0,
     & 0.00d0,  0.00d0,  0.00d0,  0.00d0,  0.00d0, 0.00d0,
     & 0.00d0,  0.00d0,  0.00d0,  0.00d0,  0.00d0, 0.00d0 /


      end module h_setkin_depos