      module h_setkin_mw
      
      use h_setkin_par, only: NSP  !!extra when converting from .h to .F
      
      implicit none
      
      public 
c=======================================================================
c
c $Id: setkin_mw.h,v 1.3 2002/02/20 15:38:31 akinorii Exp $
c
c CODE DEVELOPER
c   Peter Connell, LLNL
c   connell2@llnl.gov
c
c   "setkin_mw.h" was modified by Xiaohong Liu
c
c FILE
c   setkin_mw.h
c
c DESCRIPTION
c   This include file contains gram molecular weights
c   for the species in the model mechanism.
c
c  Chemistry input file generated: 2/23/00 10:12AM
c  Reaction dictionary:            3/29/99 2:55PM
c  Setkin files generated:         Wed Feb 23 10:30:41 2000
c
c=======================================================================

      real*8, save  :: mw_data(1:NSP)
      data mw_data(1:NSP) /
     &   34.01d0,   64.06d0,   64.06d0,   62.13d0,
     &   98.08d0,   28.96d0,   28.96d0,   28.96d0,
     &   28.96d0,   28.96d0,   28.96d0,   28.96d0,
     &   28.96d0,   28.96d0,   28.96d0,   28.96d0,
     &   28.96d0,   28.96d0,   28.96d0,   28.96d0,
     &   28.96d0,   28.96d0,   28.96d0,   28.96d0,
     &   28.96d0,   28.96d0,   28.96d0,   28.96d0,
     &   28.96d0,   28.96d0,   28.96d0,   28.96d0,
     &   28.96d0,   28.96d0,   28.96d0,   28.96d0,
     &   28.96d0,   28.96d0,   28.96d0,   28.96d0,
     &   28.96d0,   28.96d0,   28.96d0,   28.96d0,
     &   28.96d0,   28.96d0,   28.96d0,   28.96d0,
     &   28.96d0,   28.96d0,   28.96d0,   28.96d0,
     &   28.96d0,   64.06d0,   28.96d0,   28.96d0, 
     &   48.00d0,   17.01d0,   33.01d0,   62.00d0,   28.88d0 /

     
c   aerosol molecular weight is set to be MWTAIR,
c   so that mole_fraction = 1, and mass mixing ratio will be used.
c   unit of gas species: mol/mol,
c   unit of aerosol mass: kg/kg air, unit of aerosol number: #/kg air 

       end module h_setkin_mw