      module h_setkin_par
      implicit none
      public 
      
c=======================================================================
c
c $Id: setkin_par.h,v 1.5 2003/04/14 22:00:13 jrt Exp $
c
c FILE
c   setkin_par.h
c   12 JUN 02 - PSC
c
c DESCRIPTION
c   This include file sets symbolic constants for the photochemical
c   mechanism.
c
c  Chemistry input file:    2:20 PM 1/14/2003
c  Reaction dictionary:     NMHC reactions.db
c  Setkin files generated:  Tue Feb 11 19:35:44 2003
c  "setkin_par.h" was modified for sulfur chemistry by Xiaohong Liu
c
c========1=========2=========3=========4=========5=========6=========7==


       integer
     &  NSP
     & ,NUM_J
     & ,NUM_K

      parameter (NSP   =  61)
      parameter (NUM_J =   1)
      parameter (NUM_K =   8)

c.... Species affiliations and assignments

      integer
     &  NACT
     & ,NCHEM
     & ,NCONST
     & ,NDYN
     & ,NFAM
     & ,NMF
     & ,NSS

      parameter (NACT   =  55)
      parameter (NCHEM  =  60)
      parameter (NCONST =   1)
      parameter (NDYN   =  60)
      parameter (NFAM   =   1)
      parameter (NMF    =  60)
      parameter (NSS    =   0)

c.... Ancillary input tables

      integer
     &  NSAD

      parameter (NSAD  =   0)

      integer IASO2
      parameter (IASO2 = 54)

      integer IASO4
      parameter (IASO4 = 55)

      integer IAH2O
      parameter (IAH2O = 56)

      integer IO3
      parameter (IO3 = 57)

      integer IOH
      parameter (IOH = 58)

      integer IHO2
      parameter (IHO2 = 59)

      integer INO3
      parameter (INO3 = 60)

      integer IMGAS
      parameter (IMGAS = 61)


c.... Species individual identifications

      integer IC3H6
      parameter (IC3H6     =  0)

      integer IH2O
      parameter (IH2O      =  0)

      integer IN2O
      parameter (IN2O      =  0)

      integer INO
      parameter (INO       =  0)

      integer INO2
      parameter (INO2      =  0)

      integer IN2O5
      parameter (IN2O5     =  0)

      integer IHNO3
      parameter (IHNO3     =  0)

      integer IHCL
      parameter (IHCL      =  0)

      integer IHOCL
      parameter (IHOCL     =  0)

      integer ICLONO2
      parameter (ICLONO2   =  0)

      integer IHOBR
      parameter (IHOBR     =  0)

      integer IBRONO2
      parameter (IBRONO2   =  0)

      integer ICH3CCL3
      parameter (ICH3CCL3  =  0)

      integer ICCL4
      parameter (ICCL4     =  0)

      integer ICFCL3
      parameter (ICFCL3    =  0)

      integer ICF2CL2
      parameter (ICF2CL2   =  0)

      integer ICH3BR
      parameter (ICH3BR    =  0)

      integer IH1301
      parameter (IH1301    =  0)

      integer IH1211
      parameter (IH1211    =  0)

      integer ICO
      parameter (ICO       =  0)

      integer ICH4
      parameter (ICH4      =  0)

      integer IC3H6O
      parameter (IC3H6O    =  0)

      integer IC5H8
      parameter (IC5H8     =  0)

      integer IN2
      parameter (IN2       =  0)

      integer INITROGEN
      parameter (INITROGEN =  0)

      integer IOXYGEN
      parameter (IOXYGEN   =  0)

      integer IO2
      parameter (IO2       =  0)

c.... Additional model-required parameters

      integer IDEHYD
      parameter (IDEHYD   =   0)

      integer IH2OAIR
      parameter (IH2OAIR  =   0)

      integer ISYNOZ
      parameter (ISYNOZ   =   0)

      integer JBRONO21
      parameter (JBRONO21 =   0)

      integer KHNO31
      parameter (KHNO31   =   0)

c.... Species placeholders for sulfchem solver

      integer IH2O2
      parameter (IH2O2    =   1)

      integer IFSO2
      parameter (IFSO2    =   2)

      integer INSO2
      parameter (INSO2    =   3)

      integer INDMS
      parameter (INDMS    =   4)

      integer ISO4G
      parameter (ISO4G    =   5)

      integer ISO4M1
      parameter (ISO4M1   =   6)

      integer ISO4N1
      parameter (ISO4N1   =   7)

      integer ISO4M2
      parameter (ISO4M2   =   8)

      integer ISO4N2
      parameter (ISO4N2   =   9)

      integer ISO4M3
      parameter (ISO4M3   =  10)

      integer ISO4N3
      parameter (ISO4N3   =  11)

      integer ISO4NOC
      parameter (ISO4NOC  =  12)

      integer ISO4FOC
      parameter (ISO4FOC  =  13)

      integer ISO4FBC
      parameter (ISO4FBC  =  14)

      integer ISO4BOC
      parameter (ISO4BOC  =  15)

      integer ISO4BBC
      parameter (ISO4BBC  =  16)

c added by Roy
      integer ISO4OCPHl1
      parameter (ISO4OCPHl1  =  17)

      integer ISO4OCPHl2
      parameter (ISO4OCPHl2  =  18)

      integer ISO4BCPHl1
      parameter (ISO4BCPHl1  =  19)

      integer ISO4BCPHl2
      parameter (ISO4BCPHl2  =  20)

      integer ISO4CPOM
      parameter (ISO4CPOM  =  21)

      integer ISO4CBC
      parameter (ISO4CBC  =  22)

      integer ISO4APOM
      parameter (ISO4APOM  =  23)

      integer ISO4ABC
      parameter (ISO4ABC  =  24)
c
      integer ISO4D1
      parameter (ISO4D1   =  25)

      integer ISO4D2
      parameter (ISO4D2   =  26)

      integer ISO4D3
      parameter (ISO4D3   =  27)

      integer ISO4D4
      parameter (ISO4D4   =  28)

      integer ISO4S1
      parameter (ISO4S1   =  29)

      integer ISO4S2
      parameter (ISO4S2   =  30)

      integer ISO4S3
      parameter (ISO4S3   =  31)

      integer ISO4S4
      parameter (ISO4S4   =  32)

      integer INOC
      parameter (INOC     =  33)

      integer IFOC
      parameter (IFOC     =  34)

      integer IFBC
      parameter (IFBC     =  35)

      integer IBOC
      parameter (IBOC     =  36)

      integer IBBC
      parameter (IBBC     =  37)

c added by Roy
      integer IOCPHl1
      parameter (IOCPHl1  =  38)

      integer IOCPHl2
      parameter (IOCPHl2  =  39)

      integer IBCPHl1
      parameter (IBCPHl1  =  40)

      integer IBCPHl2
      parameter (IBCPHl2  =  41)

      integer ICPOM
      parameter (ICPOM     =  42)

      integer ICBC
      parameter (ICBC     =  43)

      integer IAPOM
      parameter (IAPOM     =  44)

      integer IABC
      parameter (IABC     =  45)
c
      integer IDUST1
      parameter (IDUST1   =  46)

      integer IDUST2
      parameter (IDUST2   =  47)

      integer IDUST3
      parameter (IDUST3   =  48)

      integer IDUST4
      parameter (IDUST4   =  49)

      integer ISSLT1
      parameter (ISSLT1   =  50)

      integer ISSLT2
      parameter (ISSLT2   =  51)

      integer ISSLT3
      parameter (ISSLT3   =  52)

      integer ISSLT4
      parameter (ISSLT4   =  53)

c                                  --^--

      end module h_setkin_par