      module modiag_umaer
c-----------------------------------------------------------------------
c---->define accuracy
c-----------------------------------------------------------------------
      use precision
      implicit real(kdef) (a-h,o-z), integer (i-n)
c-----------------------------------------------------------------------
c---->diagnostic quantities
c
c     so4nucn   - number of newly nucleated aerosol
c                 particles since the beginning of
c                 the simulation                       in [#particles/m3]
c     so4nucm   - mass of newly nucleated aerosol
c                 particles since the beginning of
c                 the simulation                       in [#so4 molecules/m3]
c     so4con    - condensation since the beginning
c                 of the simulation                    in [#so4 molecules/m3]
c     so4coag   - change in number concentration
c                 since the beginning of the simulation
c                 due to coagulation                   in [#particles/m3]
c     so4grvn   - change in number concentration
c                 since the beginning of the simulation
c                 due to gravitational settling        in [#particles/m3]
c     so4grvm   - change in mass concentration
c                 since the beginning of the simulation
c                 due to gravitational settling        in [#so4 molecules/m3]
c-----------------------------------------------------------------------
      real(kdef), allocatable, target, save :: 
     $                      so4nucn(:),so4nucm(:),
     $                      so4con (:),so4conn(:),
     $                      so4coag(:),so4coagn(:),
     $                      so4grvn(:),so4grvm(:),
     $                      begnuc(:,:)

      end module modiag_umaer
