c=============================================================================
c
c $Id: setup_aquchem.F,v 1.1 2003/04/14 16:59:11 dan Exp $
c
c CODE DEVELOPER
c   originated from GRANTOUR programmed by John Walton
c   modified by Xiaohong Liu
c
c FILE
c   setup_aquchem.F
c
c ROUTINES
c   Do_Setup_Aquchem
c
c=============================================================================

c-----------------------------------------------------------------------------
c
c ROUTINE
c   Do_Setup_Aquchem
c
c DESCRIPTION
c   This is the routine set up for aqueous chemistry by
c     creating a subset of the grid points with cfp > 0.01 and cwp > 1.e-9 g/g
c
c ARGUMENTS
c   itloop     : # of zones (ilong * ilat * ivert)
c   numcl      : number of grid points in cloud
c   idxcl      : array of the numbers of the numcl points in cloud
c   cfp        : total cloud fraction [0 - 1]
c   cwp        : in-cloud cloud water mixing ratio (g/g air)
c
c ---------------------------------------------------------------------------
c Change note by Cheng Zhou
c 1) include to use

      subroutine Do_Setup_Aquchem
     &  (itloop, numcl, idxcl, cfp, cwp)

      use h_sulfchem,only: ijk
      implicit none

c#     include "sulfchem.h"

c     ----------------------
c     IMPACT-related values.
c     ----------------------

      integer :: itloop, numcl
      integer :: idxcl(itloop)

      real*8  :: cfp(itloop)
      real*8  :: cwp(itloop)


      numcl = 0

      do 100 ijk = 1, itloop

        if (cfp(ijk) .gt. 0.01 .and. cwp(ijk) .gt. 1.e-9) then
          idxcl(numcl+1) = ijk
          numcl = numcl + 1
        else
          cfp(ijk) = 0.
          cwp(ijk) = 0.
        endif

  100 continue


      return

      end

